enemies = {}

function enemy_update(dt)
	for i,v in ipairs(enemies) do
		-- Movement
		if(v.stun == false) then
			if(v.chase == false and v.home == false) then
				if(v.d == 1) then
					v.x = v.x + v.speed * v.facing * dt

					for i,j in ipairs(d1) do
						if CheckCollision(v.x + screen.x,v.y - screen.y,v.w,v.w,j.x + screen.x,j.y - screen.y,j.w,j.h) then
							v.facing = 1
						end
					end
					for i,j in ipairs(d2) do
						if CheckCollision(v.x + screen.x,v.y - screen.y,v.w,v.w,j.x + screen.x,j.y - screen.y,j.w,j.h) then
							v.facing = -1
						end
					end
				end
				
				if(v.d == 2) then
					v.y = v.y + v.speed * v.facing * dt
					for i,j in ipairs(d1) do
						if CheckCollision(v.x + screen.x,v.y - screen.y,v.w,v.w,j.x + screen.x,j.y - screen.y,j.w,j.h) then
							v.facing = 1
						end
					end
					for i,j in ipairs(d2) do
						if CheckCollision(v.x + screen.x,v.y - screen.y,v.w,v.w,j.x + screen.x,j.y - screen.y,j.w,j.h) then
							v.facing = -1
						end
					end
				end
			end
			if(v.chase == true) then
				if (distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, 400, v.w*0.5)) then

				else
					v.chase = false
					v.home = true				
				end
			
				local startX = v.x - v.w/2 + screen.x
				local startY = v.y - v.w/2 - screen.y
				local playerX = player.x
				local playerY = player.y
				
				local angle = math.atan2((playerY - startY), (playerX - startX))
				local Dx = (v.speed * 2) * math.cos(angle)
				local Dy = (v.speed * 2) * math.sin(angle)
				
				v.x = v.x + (Dx * dt)
				v.y = v.y + (Dy * dt)
				
				bulStartX = v.x + v.w/2 + screen.x
				bulStartY = v.y + v.w/2 - screen.y
				if(v.firerate > 0) then
					v.firerate = v.firerate - 1 * dt
				end
				if(v.firerate < 0) then
					enemy_shoot()
					v.firerate = 0.5
				end
			end
			if(v.home == true) then
				if (distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, v.endX + screen.x, v.endY - screen.y, 50, 5)) then
					v.home = false
					v.x = v.endX
					v.y = v.endY
				end
				local startX = v.x - v.w/2 + screen.x
				local startY = v.y - v.w/2 - screen.y
				local playerX = v.endX + screen.x
				local playerY = v.endY - screen.y
				
				local angle = math.atan2((playerY - startY), (playerX - startX))
				local Dx = (v.speed * 2) * math.cos(angle)
				local Dy = (v.speed * 2) * math.sin(angle)
				
				v.x = v.x + (Dx * dt)
				v.y = v.y + (Dy * dt)			
			end
			
			--Collision
			if distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, player.sound, v.w*0.5) and v.chase == false then
				--player.hit = true
				v.endX = v.x 
				v.endY = v.y
				v.chase = true
				v.draw = true
			else
				--nothing
			end
		end
		if(v.stun == true) then
			v.sound = 15
		end
	end
	
	for i,v in ipairs(enemyBullets) do
		if(love.keyboard.isDown("w"))then
			v.my = v.my + player.speed * dt
		end
		if(love.keyboard.isDown("s"))then
			v.my = v.my - player.speed * dt
		end
		if(love.keyboard.isDown("a"))then
			v.mx = v.mx + player.speed * dt
		end
		if(love.keyboard.isDown("d"))then
			v.mx = v.mx - player.speed * dt
		end
	
		v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
	end
end

enemyBulletSpeed = 2000
enemyBullets = {}
bulStartX = 0
bulStartY = 0

function enemy_shoot()
	local startX = bulStartX
	local startY = bulStartY
	local playerX = player.x + math.random(-30,30)
	local playerY = player.y + math.random(-30,30)
			
	local angle = math.atan2((playerY - startY), (playerX - startX))
			
	local bulletDx = enemyBulletSpeed * math.cos(angle)
	local bulletDy = enemyBulletSpeed * math.sin(angle)
			
	table.insert(enemyBullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy, mx = 0, my = 0})	
end

function enemy_draw()
	love.graphics.setColor(255,0,0)
	for i,v in ipairs(enemies) do
		
		if(v.draw == true or love.keyboard.isDown("/")) then
			love.graphics.circle("line", v.x + 10 + screen.x, v.y + 10 - screen.y, v.sound)
			love.graphics.rectangle("fill",v.x + screen.x,v.y - screen.y,v.w,v.w)
		end
	end
	for i,v in ipairs(enemyBullets) do
		love.graphics.circle("fill",v.x + v.mx,v.y + v.my,3)
	end
		
	love.graphics.setColor(255,255,255)
end