dartSpeed = 1000
    
darts = {}
micros = {}

pencil = love.graphics.newImage("gfx/pencil.png")
micro = love.graphics.newImage("gfx/micro.png")
dart = love.graphics.newImage("gfx/dart.png")

function items_update(dt)
	for i,v in ipairs(darts) do
		v.x = v.x + (v.dx * dt)
		v.y = v.y + (v.dy * dt)
		for i,j in ipairs(enemies) do
			if CheckCollision(v.x + screen.x, v.y - screen.y, 3,3, j.x + screen.x, j.y - screen.y,j.w,j.w) then
				j.stun = true
			end
		end
		for k,j in ipairs(ob) do
			if CheckCollision(v.x + screen.x, v.y - screen.y, 3,3,  j.x + screen.x,j.y - screen.y,j.w,j.h) then
				table.remove(darts,i)
			end
		end
	end
	
	for i,v in ipairs(micros) do
		for i,j in ipairs(enemies) do
			if distBasedCollision(v.x + screen.x,v.y - screen.y,j.x + screen.x,j.y - screen.y,v.range,j.sound) then
				j.draw = true
			end
		end
	end
end

function items_draw()
	for i,v in ipairs(darts) do
		love.graphics.circle("fill", v.x + screen.x, v.y - screen.y, 3)
	end
	for i,v in ipairs(micros) do
		love.graphics.circle("line", v.x + screen.x, v.y - screen.y, v.range)
	end
	love.graphics.draw(pencil, 500,600)
	love.graphics.draw(micro, 600,600)
	love.graphics.print(player.micros,650,650)
	love.graphics.draw(dart, 700,600)
	love.graphics.print(player.darts, 750,650)
	if(player.item == 1) then
		love.graphics.rectangle("line",500,600,100,100)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("line",600,600,100,100)
		love.graphics.rectangle("line",700,600,100,100)
		love.graphics.setColor(255,255,255)
	elseif(player.item == 2) then
		love.graphics.rectangle("line",600,600,100,100)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("line",500,600,100,100)
		love.graphics.rectangle("line",700,600,100,100)
		love.graphics.setColor(255,255,255)
	elseif(player.item == 3) then
		love.graphics.rectangle("line",700,600,100,100)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("line",500,600,100,100)
		love.graphics.rectangle("line",600,600,100,100)
		love.graphics.setColor(255,255,255)
	end
end

function love.mousepressed(x, y, button)
	
	if(gamestate == "playing") then
		if button == "l" and player.item == 3 and player.darts > 0 then
			player.darts = player.darts - 1
			local startX = player.x + player.w/ 2
			local startY = player.y + player.w / 2
			local mouseX = x
			local mouseY = y
			
			local angle = math.atan2((mouseY - startY), (mouseX - startX))
			
			local dartDx = dartSpeed * math.cos(angle)
			local dartDy = dartSpeed * math.sin(angle)
			
			table.insert(darts, {x = startX  - screen.x, y = startY + screen.y, dx = dartDx, dy = dartDy})
		end
		if(button == "l" and player.item == 2 and player.micros > 0) then
			m = {}
			m.range = 200
			m.x = - screen.x + player.x
			m.y = screen.y + player.y
			
			player.micros = player.micros - 1
			table.insert(micros,m)
		end
	end
end