player = {}
player.x = 1280/2
player.y = 720/2
player.w = 20

player.health = 5

player.soundLevel = 30
player.sound = 30
player.speed = 100
player.curSpeed = 100
player.walk = 100
player.sprint = 400
player.inc = 100
player.hit = false

player.sense = 0
player.senseRange = 500
player.sensePic = love.graphics.newImage("gfx/sense.png")

player.walking = false
player.stepCounter = 0
player.stepTime = 1

player.hitLeft = false
player.hitRight = false
player.hitTop = false
player.hitBot = false

player.leftH = 10
player.leftW = 6

player.rigthH = 10
player.rightW = 6

player.topH = 6
player.topW = 10

player.botH = 6
player.botW = 10

player.item = 1
player.darts = 3
player.micros = 3

step = love.audio.newSource("footstep.ogg")

function player_update(dt)
	--Item select
	if(love.keyboard.isDown("1")) then
		player.item = 1 --Drawing
	elseif (love.keyboard.isDown("2")) then
		player.item = 2 --Stun dart
	elseif (love.keyboard.isDown("3")) then
		player.item = 3 --Microphone
	end
	--Movement
	if(love.keyboard.isDown("w") and player.hitTop == false) then
		--player.y = player.y - player.speed * dt
		screen.y = screen.y - player.speed * dt
	end
	if(love.keyboard.isDown("s") and player.hitBot == false) then
		--player.y = player.y + player.speed * dt
		screen.y = screen.y + player.speed * dt
	end
	if(love.keyboard.isDown("a") and player.hitLeft == false) then
		--player.x = player.x - player.speed * dt
		screen.x = screen.x + player.speed * dt
	end
	if(love.keyboard.isDown("d") and player.hitRight == false) then
		--player.x = player.x + player.speed * dt
		screen.x = screen.x - player.speed * dt
	end
	if(love.keyboard.isDown("w") or love.keyboard.isDown("s") or love.keyboard.isDown("a") or love.keyboard.isDown("d")) then
		player.walking = true
	else
		player.walking = false
	end
	if(love.keyboard.isDown(" ")) then
		player.speed = player.sprint
		player.soundLevel = 50
	else if(love.keyboard.isDown("lshift")) then
		player.soundLevel = 20
		player.speed = player.walk/2
	else
		player.speed = player.walk
		player.soundLevel  = 30
	end
	end
	--Smooth Sound
	if(player.walking == true) then
		
		player.stepCounter = player.stepCounter + player.soundLevel * player.stepTime * dt 
		if(player.stepCounter > player.soundLevel/5) then
			player.stepTime = -1
			player.stepCounter = 4
			love.audio.play(step)
		end
		if(player.stepCounter < 0) then
			player.stepTime = 1
			player.stepCounter = 1
		end
		player.soundLevel = player.soundLevel + player.stepCounter
	end
	if(player.walking == false) then
		player.soundLevel = 15
	end
	
	if(player.sound > player.soundLevel) then
		player.sound = player.sound - player.inc * dt
	elseif (player.sound < player.soundLevel and player.walking == true) then
		player.sound = player.sound + player.inc * dt
	end
	--Collision World
	player.hitLeft = false
	player.hitRight = false
	player.hitTop = false
	player.hitBot = false
	for i,v in ipairs(ob) do
		--left
		if CheckCollision(player.x - player.leftW/2,player.y + player.w/2 - player.leftH/2,player.leftW ,player.leftH, v.x + screen.x,v.y - screen.y,v.w,v.h) then
			player.hitLeft = true
		end
		--right
		if CheckCollision(player.x + player.w -player.rightW/2 ,player.y + player.w/2 - player.rigthH/2,player.leftW ,player.leftH, v.x + screen.x,v.y - screen.y,v.w,v.h) then
			player.hitRight = true
		end
		--top
		if CheckCollision(player.x + player.w/2 - player.topW/2, player.y - player.topH/2, player.topW, player.topH, v.x + screen.x,v.y - screen.y,v.w,v.h) then
			player.hitTop = true
		end
		--bot
		if CheckCollision(player.x + player.w/2 - player.topW/2, player.y - player.topH/2 + player.w, player.botW, player.botH, v.x + screen.x,v.y - screen.y,v.w,v.h) then
			player.hitBot = true
		end	
	end
	-- Collision Enemies
	player.sense = 0
	for i,v in ipairs(enemies) do
		v.draw = false
		if distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, v.sound, player.w*0.5) then
			v.draw = true
		end
	end
	for i,v in ipairs(enemies) do
		if distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, player.senseRange, player.w*0.5) then
			player.sense = 1
		end
	end
	for i,v in ipairs(enemies) do
		if distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, player.senseRange / 2, player.w*0.5) then
			player.sense = 2
		end
	end
	for i,v in ipairs(enemies) do
		if distBasedCollision(v.x + 10 + screen.x, v.y + 10 - screen.y, player.x + 10, player.y + 10, player.senseRange / 3, player.w*0.5) then
			player.sense = 3
		end
	end
	--Collision Bullets
	for i,v in ipairs(enemyBullets) do
		if CheckCollision(player.x, player.y, player.w, player.w, v.x + v.mx,v.y + v.my,3,3) then
			player.health = player.health - 1
			table.remove(enemyBullets, i)
		end
	end
	if(player.health < 1) then
		player.hit = true
	end
	-- Colision Gold
	for i,v in ipairs(gold) do
		if CheckCollision(player.x, player.y , player.w, player.w, v.x + screen.x, v.y - screen.y, v.w, v.h) then
			table.remove(gold, i)
			goldCount = goldCount - 1
		end
	end
	-- Exit Collision
	if(goldCount == 0) then
		for i,v in ipairs(exits) do
			if CheckCollision(player.x, player.y, player.w, player.w, v.x + screen.x, v.y - screen.y, v.w, v.h) then
				reset()
				level = level + 1
				levelmap = love.graphics.newImage("level/map"..level..".png")
				imageData = love.image.newImageData("level/map"..level..".png")
				screen.x = spawnX
				screen.y = spawnY
				load_map()
			end
		end
	end
	if(love.keyboard.isDown("e")) then
		goldCount = 0
	end
	items_update(dt)
	
end

function player_draw()
	if(player.sense == 1) then
		love.graphics.draw(player.sensePic,100,50)
	elseif(player.sense == 2) then
		love.graphics.draw(player.sensePic,100,50)
		love.graphics.draw(player.sensePic,200,50)
	elseif (player.sense == 3) then
		love.graphics.draw(player.sensePic,100,50)
		love.graphics.draw(player.sensePic,200,50)
		love.graphics.draw(player.sensePic,300,50)
	end
	love.graphics.rectangle("fill",100,200,player.health * 20, 20)
	--if(player.hit == true) then
		
	--end
	love.graphics.circle("line", player.x + 10, player.y + 10, player.sound)
	--love.graphics.circle("line", player.x + 10, player.y + 10, player.w*0.5)
	love.graphics.rectangle("fill", player.x, player.y, player.w, player.w)
	if(goldCount > 0) then
		love.graphics.print(goldCount, 1000,50)
		love.graphics.setColor(255,255,0)
		love.graphics.rectangle("fill",940,30,50,50)
		love.graphics.setColor(255,255,255)
	else
		love.graphics.print("Get to the exit", 1000,50)
	end
	
	
	--love.graphics.setColor(255,0,0)
	--left
	--love.graphics.rectangle("fill",player.x - player.leftW/2,player.y + player.w/2 - player.leftH/2,player.leftW ,player.leftH)
	--right
	--love.graphics.rectangle("fill",player.x + player.w -player.rightW/2 ,player.y + player.w/2 - player.rigthH/2,player.leftW ,player.leftH)
	--top
	--love.graphics.rectangle("fill", player.x + player.w/2 - player.topW/2, player.y - player.topH/2, player.topW, player.topH)
	--bot
	--love.graphics.rectangle("fill", player.x + player.w/2 - player.topW/2, player.y - player.topH/2 + player.w, player.botW, player.botH)
	
	--love.graphics.setColor(255,255,255)
end